/*
 * Copyright (c) 2015, StrategyQuant - All rights reserved.
 *
 * Code in this file was made in a good faith that it is correct and does what it should. 
 * If you found a bug in this code OR you have an improvement suggestion OR you want to include 
 * your own code snippet into our standard library please contact us at:
 * http://tasks.strategyquant.com/projects/snippets/
 *
 * This code can be used only within StrategyQuant products. 
 * Every owner of valid (free, trial or commercial) license of any StrategyQuant product 
 * is allowed to freely use, copy, modify or make derivative work of this code without limitations,
 * to be used in all StrategyQuant products and share his/her modifications or derivative work 
 * with the StrategyQuant community.
 *  
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, 
 * INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR 
 * PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES 
 * OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, 
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *  
 */
package com.strategyquant.extend.DatabankActions;

import java.io.File;
import java.util.ArrayList;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import com.strategyquant.core.gui.tables.DynamicTableToCsv;
import com.strategyquant.lib.app.MainApp;
import com.strategyquant.lib.databank.Databank;
import com.strategyquant.lib.databank.DatabankAction;
import com.strategyquant.lib.files.RecentFilesAndPaths;
import com.strategyquant.lib.language.L;
import com.strategyquant.lib.results.SQResultsGroup;
import com.strategyquant.lib.settings.SQCoreConst;
import com.strategyquant.lib.time.SQTime;

public class ExportToCSV extends DatabankAction {
	public static final Logger Log = LoggerFactory.getLogger("ExportToCSV");
	
	private Databank databank;
	
	public ExportToCSV() {
		setName("Save:"+L.t("Export to CSV"));
	}
	
	@Override
	public void execute(Databank databank) {
		this.databank = databank;
		
		ArrayList<SQResultsGroup> strategyResults = databank.getSelectedResults();
		
		if(strategyResults.size() <= 0) {
			JOptionPane.showMessageDialog(MainApp.getFrame(), 
					L.t("Please select at least one report using checkbox."),
					L.t("Info"),
	    		    JOptionPane.INFORMATION_MESSAGE);	

			return;
		}
				
		save(strategyResults);
	}

	private void save(ArrayList<SQResultsGroup> strategyResults) {
		SQResultsGroup sr = strategyResults.get(0);
		
		JFileChooser chooser = new JFileChooser();
		FileNameExtensionFilter filter = new FileNameExtensionFilter(L.t("Comma Separated File"), "csv");
        chooser.setFileFilter(filter);
        chooser.setMultiSelectionEnabled(false);

        String dir = RecentFilesAndPaths.getPath(RecentFilesAndPaths.CSV_REPORTS);
        chooser.setCurrentDirectory(new File(dir));
    	        
    	SQTime dt = new SQTime();
    	String date =  dt.toDateString().replace('.', '_');
        
    	String fileName = dir+"/"+databank.getName()+"_"+date+ ".csv";

    	File f = new File(fileName);
    	chooser.setSelectedFile(f);
        
        int returnVal = chooser.showSaveDialog(null);
        if (returnVal == JFileChooser.APPROVE_OPTION && chooser.getSelectedFiles() != null) {
        	RecentFilesAndPaths.savePath(RecentFilesAndPaths.CSV_REPORTS, chooser.getCurrentDirectory().getAbsolutePath());
        	
        	boolean save = false;
        	
        	if(chooser.getSelectedFile().exists()) {
        		int ret = JOptionPane.showConfirmDialog(
        				MainApp.getFrame(),
        				L.t("The file with given name already exists, do you want to overwrite it?"),
        				L.t("Confirm file overwrite"),
        				JOptionPane.YES_NO_OPTION);

        		if (ret == JOptionPane.YES_OPTION) {
        			save = true;
        		}
        	} else {
        		save = true;
        	}
        	
        	DynamicTableToCsv.export(databank.getDatabankTable(), chooser.getSelectedFile().getAbsolutePath());
        }
    }
	
	@Override
	public String getProduct() {
		return SQCoreConst.PRODUCT_ANY;
	}
	
	@Override
	public int getPreferredPosition() {
		return 3;
	}
}